# Class FontLineShapeRenderer

java.lang.Object
org.jmol.render.ShapeRenderer
org.jmol.render.FontLineShapeRenderer

Direct Known Subclasses:
  `AxesRenderer, BbcageRenderer, LabelsRenderer, SticksRenderer, UccageRenderer`

public abstract class FontLineShapeRenderer extends ShapeRenderer

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`asLineOnly`
`protected short`
`colixA`
`protected short`
`colixB`
`protected int[]`
`dashDots`
`protected static final int[]`
`dashes`
`protected boolean`
`dotsOrDashes`
`protected boolean`
`draw000`
`protected byte`
`endcap`
`protected Font`
`font3d`
`protected static final int[]`
`fourdots`
`protected static final int[]`
`hDashes`
`protected float`
`imageFontScaling`
`protected static final int[]`
`ndots`
`protected final P3`
`pointT`
`protected final P3`
`pointT2`
`protected final P3`
`pointT3`
`protected P3`
`pt0`
`protected final P3i`
`pt0i`
`protected P3`
`pt1`
`protected final P3i`
`pt2i`
`protected static final int[]`
`pymoldashes`
`protected final P3i`
`s1`
`protected final P3i`
`s2`
`protected static final int[]`
`sixdots`
`protected P3`
`tickA`
`protected P3`
`tickAs`
`protected P3`
`tickB`
`protected P3`
`tickBs`
`protected TickInfo`
`tickInfo`
`protected static final int[]`
`twodots`
`protected final V3`
`vectorT`
`protected final V3`
`vectorT2`
`protected final V3`
`vectorT3`
`protected int`
`width`

### Fields inherited from class ShapeRenderer

`colix, exportType, flags, g3d, isExport, mad, ms, myVisibilityFlag, shape, shapeID, tm, vwr`

## Constructor Summary

Constructors
Constructor
Description
`FontLineShapeRenderer()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`checkTickTemps()`
`protected static void`
`drawDashedCylinder(JmolRendererInterface g3d, int xA, int yA, int zA, int xB, int yB, int zB, int[] array, int width, short colixA, short colixB, int renderD, boolean asLineOnly, P3i s1)`
`protected int`
`drawLine(int x1, int y1, int z1, int x2, int y2, int z2, int diameter)`
`protected int`
`drawLine2(JmolRendererInterface g3d, int x1, int y1, int z1, int x2, int y2, int z2, int diameter)`
`protected void`
`drawString(int x, int y, int z, int radius, boolean rightJustify, boolean centerX, boolean centerY, int yRef, String sVal)`
`protected void`
`drawTicks(int diameter, boolean withLabels)`
`protected static void`
`fillCylinder(JmolRendererInterface g3d, short colixA, short colixB, byte endcaps, int xA, int yA, int zA, int xB, int yB, int zB, int diameter, boolean asLineOnly)`
`protected int`
`getDiameter(int z, int mad10OrPixels)`
`protected void`
`renderLine(P3 p0, P3 p1, int diameter, boolean drawTicks)`

### Methods inherited from class ShapeRenderer

`initRenderer, isVisibleForMe, render, renderShape, setup, setViewerG3dShapeID`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### dashes

protected static final int[] dashes

### hDashes

protected static final int[] hDashes

### pymoldashes

protected static final int[] pymoldashes

### ndots

protected static final int[] ndots

### sixdots

protected static final int[] sixdots

### fourdots

protected static final int[] fourdots

### twodots

protected static final int[] twodots

### colixA

protected short colixA

### colixB

protected short colixB

### dotsOrDashes

protected boolean dotsOrDashes

### dashDots

protected int[] dashDots

### asLineOnly

protected boolean asLineOnly

### imageFontScaling

protected float imageFontScaling

### tickA

protected P3 tickA

### tickB

protected P3 tickB

### tickAs

protected P3 tickAs

### tickBs

protected P3 tickBs

### font3d

protected Font font3d

### pt0i

protected final P3i pt0i

### pt2i

protected final P3i pt2i

### s1

protected final P3i s1

### s2

protected final P3i s2

### pointT

protected final P3 pointT

### pointT2

protected final P3 pointT2

### pointT3

protected final P3 pointT3

### vectorT

protected final V3 vectorT

### vectorT2

protected final V3 vectorT2

### vectorT3

protected final V3 vectorT3

### tickInfo

protected TickInfo tickInfo

### draw000

protected boolean draw000

### width

protected int width

### endcap

protected byte endcap

### pt0

protected P3 pt0

### pt1

protected P3 pt1

## Constructor Details

### FontLineShapeRenderer

public FontLineShapeRenderer()

## Method Details

### getDiameter

protected int getDiameter(int z, int mad10OrPixels)

### renderLine

protected void renderLine(P3 p0, P3 p1, int diameter, boolean drawTicks)

### checkTickTemps

protected void checkTickTemps()

### drawTicks

protected void drawTicks(int diameter, boolean withLabels)

### drawLine

protected int drawLine(int x1, int y1, int z1, int x2, int y2, int z2, int diameter)

### drawLine2

protected int drawLine2(JmolRendererInterface g3d, int x1, int y1, int z1, int x2, int y2, int z2, int diameter)

### drawString

protected void drawString(int x, int y, int z, int radius, boolean rightJustify, boolean centerX, boolean centerY, int yRef, String sVal)

### drawDashedCylinder

protected static void drawDashedCylinder(JmolRendererInterface g3d, int xA, int yA, int zA, int xB, int yB, int zB, int[] array, int width, short colixA, short colixB, int renderD, boolean asLineOnly, P3i s1)

### fillCylinder

protected static void fillCylinder(JmolRendererInterface g3d, short colixA, short colixB, byte endcaps, int xA, int yA, int zA, int xB, int yB, int zB, int diameter, boolean asLineOnly)